// ************************ jsForm generator
// formgen 0.2.12 21 April 2021
// free to use but no warranties
// El Condor - Condor Informatique - Turin
// *****************************************
if (typeof(window.$) != "function") var $ = function (id) {return document.getElementById(id);};  // wrap getElementById
formGen = function(idDiv,param,cBack) {
/* ************************* some functions *************************/
	var sanitize = function(s) { // deMask , ; = &
		if (s.substring(0,1) == "@") s = aRep[s];
		return s.replace(/\\x2C|\\x3B|\\x3D|\\x26/gi,function(s){return String.fromCharCode(parseInt("0"+s.substring(1)))});
	};
	var splitKeyValue = function(aSplit) {	// return array of items
		var aRet = new Array();
		for (var i in aSplit) {
			if (!/^\s*$/.test(aSplit[i])) {
				var a = sanitize(aSplit[i]).split("=")	// sanitize possible 'key=value'
				a[a.length-1] = translate(fg_dictionary,sanitize(a[a.length-1]))
				aRet[aRet.length] = [a[0],(a.length > 1) ? a[1]:a[0]];
			}
		}
		return aRet;
}
	var check = function(frm,widget) {	// can controls all form or only the widget
		if (typeof widget == "undefined") var widget = "";
		var controls = formGen[frm.fg_Store.value].controls
		var aErrors = [];
		for (var field in controls) {
			var aItems = controls[field];
			if (field == "*") {		// general check
				var checkAnswer = window[aItems[0][1]](frm);
				if (checkAnswer != "") aErrors[aErrors.length] = checkAnswer;
				continue
			}	
			if (widget != "" && widget.name != field) continue;
			var widgetValue = (widget == "") ? frm[field].value : widget.value;
			var clr = "";	// if error is red
			frm[field].style.borderColor = "gray";
			for (k=0;k<aItems.length;k++) {
				switch (aItems[k][0]) {
					case "MIN":
						if (parseFloat(widgetValue) < parseFloat(aItems[k][1])) clr = "red";
						break;			
					case "MAX":
						if (parseFloat(widgetValue) > parseFloat(aItems[k][1])) clr = "red";
						break;
					case "PATTERN":
						if (widgetValue != "") {
							var regExpr = new RegExp(sanitize(aItems[k][1]));
							if (!regExpr.test(widgetValue)) clr = "red";
						}
						break;
					case "MAIL":
						if (widgetValue != "") {
							if (!/^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/.test(widgetValue)) clr = "red";
						}
						break;
					case "FUNCTION":
						if (!window[aItems[k][1]](frm,field,widgetValue)) clr = "red";
						break;
					case "REQUIRED":
						if (/^\s*$/.test(widgetValue)) clr = "red";
						break;
				}
				if (clr != "") {
					aErrors[aErrors.length] = field+": "+aItems[k][2];					
					frm[field].style.borderColor = clr;
					var clr = "";	// if error is red
					if (aItems[k][0] == "REQUIRED") break;
				}
			}
		}
		return aErrors;
	};
	var storeDefaults = function(item,def) {	// used for store defaults
		if (!Array.isArray(item)) item = item.split(",");
		for (var j=0;j<item.length; j++) {
			var itemDef = item[j].split(/\s*=/);
			if (itemDef.length == 2) {def[itemDef[0]] = sanitize(itemDef[1]);};
		}
	}
	var createOptions = function(id,listItems) {	// lists and combos
		if ($(id) == null) return;
		var defaults = formGen[$(id).form.fg_Store.value].defaults;
		var widgets = formGen[$(id).form.fg_Store.value].widgets;
		var frm = formGen[$(id).form.fg_Store.value].jsForm[0];		
		var name = id.substr(frm.length);
		var x = $(id);
		if (widgets[name][0] == "L") x = $(id+"_List");
		x.innerHTML = ""
		aItems = splitKeyValue(listItems.split(","));	// clean list
		var opt = ""
		var group = "";
		for (k=0;k<aItems.length;k++) {
			var disabled = "";
			if (aItems[k][0] == "|") {
				disabled = " disabled style='font-weight:bold;font-style:italic'";
				group = aItems[k][1];
			}
			opt += "<option Value='" + aItems[k][0] + "'" + disabled + ">" + aItems[k][1] + "</option>"
			listGroups[id+aItems[k][0]] = group;
			if (typeof defaults[name] != "undefined") {
				if (aItems[k][1] == defaults[name]) {
					defaults[name] = aItems[k][0];	// key if default supplied is value
				}
			} else $(id).value = "";		
		}
		x.innerHTML = opt;
		if (typeof defaults[name] == "undefined") x.selectedIndex = -1
		else $(id).value = defaults[name];
		return aItems.length;
	}
	var addHidden = function(frm,name,value) {
		var hidden = document.createElement("input");
		hidden.setAttribute("type","hidden");
		hidden.setAttribute("name",name);
		if (typeof value != "undefined") hidden.setAttribute("value",value);
		frm.appendChild(hidden)
	}
	var	existsSubmitButton = function(aBtn) {	// checks if exists a submit button
		for (j in aBtn) {if (aBtn[j][0] == "BOTTOM" && !(/fg_Cancel$|fg_Reset$/.test(j))) return true;}
		return false;
	};
	var genButton = function(frm,name,btn) {
		if (!(btn[3] in btnTypes)) return btn[4];
		btn[5] = translate(fg_dictionary,sanitize(btn[5]));
		let eventBtn = " onClick='";
		if (name != "fg_Reset") {
			let result = rgxAlert.exec(btn[4])
			if (result !== null) eventBtn += "alert(\""+translate(fg_dictionary,result[1])+"\")'"
			else eventBtn += "formGen.prototype.handle(this.form,\""+name+"\""
				+((btn[4] == "" || btn[4].toLowerCase() == "submit")?",\"submit\"":","+btn[4])+")'"
		} else {
			eventBtn += "formGen.prototype.setDefaults(this.form[\"fg_Store\"].value)'"
		}
		var titleBtn = " title='" + btn[5] + "'";
//		var styleBtn = " class='fg_"+btn[3]+"utton'" 
		+ ((btn[6] != "" &&  btn[3] != "IB") ? " style='width:" + btn[6] + "px'":"");
		var idBtn = (name.substr(0,3) != "fg_") ? " id='" + frm + name + "'":"";		// no ID for standard buttons				
//		var b = "\n<button type='button' name='" + name +"'" + eventBtn + styleBtn + idBtn + titleBtn + ">";
		var b = "\n<button type='button' name='" + name +"'" + eventBtn + idBtn + titleBtn;
		b += (btn[3] == "GB" || btn[3] == "IB") ? " class='fg_GButton'><img src='" + btn[2] + "' class='fg_GButton'>":translate(fg_dictionary,btn[2])+"></button>";
		if (btn[3] == "IB") {
//			b = b+"<span style='width:" + btn[6] + "px;display:inline-block'>"+btn[5] + "</span>";
			b = b+"<span>"+btn[5] + "</span>";
		}
		return b;
	};	
	var hasAfterBelow = function(field,aBtns) {
		var r = 0;
		for (let j in aBtns) {
			if (field == aBtns[j][1]) {
				if (aBtns[j][0] == "AFTER") r |= 1;
				else r |= 2;				
			}
		}
		return r
	}
	var log10 = val => Math.log(val) / Math.LN10;
	var setLabelClass = (label,tag) => "<"+tag+" class='fg_Label'>"+label+"</"+tag+">";
	var insertEraseMark = (id,name,events) => {
		events[name+"_fg"] = Array("click","formGen.prototype.handleClick");		// event for erase text fields
		return "<span style='margin-left:-11px;margin-right:5px;cursor:pointer' title='Erase' id='"+id+"_fg' >&#x2718;</span>";
	}
	formFields = function(frm,ret) {	// ret = true returns modified fields
		if (typeof ret == "undefined") var ret = false;
		var f = {};
		for (i = 0; i < frm.length; i++) {
			name = frm.elements[i].name;
			switch (frm.elements[i].type) {
				case "checkbox":
					f[name] = (frm.elements[i].checked)?frm.elements[i].value:"";
					break;
				case "button":
					f[name] = (frm.elements[i].disabled)?"off":frm.elements[i].value;
					break;
				case "radio":
					if (frm.elements[i].checked) f[name] = frm.elements[i].value;
					break;
				case "hidden":
					if (name.substr(0,3) != "fg_") f[name] = frm.elements[i].value
					break;
				default:
					f[name] = frm.elements[i].value
			}		
		}
		if (!ret) formFields["fieldsAtStart"] = f;
		else {
			for (const name in formFields.fieldsAtStart) {
				if (formFields.fieldsAtStart[name] == f[name]) delete f[name];
			}
			return Object.keys(f).join(",");			
		}
}
	idNameSize = function (wdg,defaults) {		// prepare input field
		var ctrl = "id='"+jsForm[0]+wdg[1] + "' name='"+wdg[1] + "'";
		if ("NNSNF".indexOf(wdgType) == -1) ctrl += " size='" + +wdg[3] + "'"
		wdg[4] = translate(fg_dictionary,wdg[4])
		if (wdgType.substr(0,1) == "U") {
			if (wdg[4] != "") defaults[wdg[1]] = wdg[4];		// field value
			ctrl += " readonly class='fg_UType'";
		} else {	
			if (wdg[4] != "") ctrl += " placeholder='" + wdg[4] + "'";	// hint
		}
		return ctrl;
	};
/* ************************* end some functions *************************/
	if (idDiv.trim() == "") idDiv = "fg_PopUp";
	if(!$(idDiv)) {	// if div is not present is create as PopUp
		var link = document.createElement('DIV');
		link.setAttribute('id', idDiv);
		link.className = 'fg_PopUp';
		document.body.appendChild(link);
	}
	if (typeof param == "undefined") var param = $(idDiv).innerHTML;
	var callBack = "";
	if (typeof cBack != "undefined") callBack = cBack;
	if (param == "") param = "C,,Nodata!";
	var singleName = ""			//	for unique combo
	var store = "fg_"+idDiv;	// must be here for output ID
	var widgets = {};			// widgets array
	var wType = {};				// name: type
	var defaults = {};
	var links = {};				// links combo to field
	var jsForm = new Array("","","","","","","T","fg_Form");			// what function?
	var llText = 50;			// limit from text and textarea
	var events = new(Array);
	var controls = {};				// controls
	var aLists = {};				// Lists and combos array
	var aGets = new(Array);			// GETs array
	var listGroups = new Array();	// Lists and combos group array
/************************** Check protected fields and remove cr\lf ******************************/	
	const regex = /[,=]?('(.*?)'|"(.*?)")[,;]/sm;
	var aRep = [0];		// array of replacements
	do {
	  param = (param + ";").replace(regex,(p1,p2,p3,p4) => {
			aRep[0] = aRep[0] + 1;
			var needle = (typeof p3 == "undefined") ? p4:p3;
			var rep = "@" + aRep[0] + "@";
			aRep[rep] = needle;		// .slice(1,-1)
			return p1.substring(0,1)+rep+p1.slice(-1);
		});
	} while (param.search(regex) > 0);	
	var wdg = (param.replace(/\n|\r/g,"")).split(";");
/************************** End check protected fields and remove cr\lf ****************************/	
	var convertType = {TEXT: "T", PSW: "P", LIST: "L", FILE:"F",SLIDER:"S",RDB:"R",RV:"R",IMG:"I",IMAGE:"I",
				COMMENT: "C",CONTROL: "CHECK",REQUIRED:"REQ",HIDDEN:"H",DEFAULTS:"DEFAULT",DICTIONARY:"DICT"}
// ****************** lacks of Date and Time
	var cTypes = {C:"",CE:"",CS:""}		// comments type
	var btnTypes = {B:"",GB:"",IB:""}	// buttons type
	var types = {T: "T",N: "T",NS: "T",NF: "T",P: "T",L: "T",F: "FT",S: "T",CMB: "C",CKL:"T",
				R:"C",CKB:"T",DATE:"T",TIME:"T",H:"",I:"",U:"",UN:""}
	types = Object.assign(types,cTypes,btnTypes)
	var lengths = {S:150,NF:9,NS:7,N:6,IB:150,UN:6}	// if no length is provided is 20 characters for texts
	var typeForm = "";		// typeForm: T = text, B = buttons, C = combo box or RadioButtons
// ******************************* start build *************************	
	var i,j,k;
	var ajaxEvent = 0;	// count get for list and default
	var aButtons = {};
	fg_dictionary = {};
	const rgxIxmgFiles = /.+(\.png|\.gif|\.jpeg|\.jpg|\.gif|\.ico)$/mi;
	const rgxAlert = /^\s*alert:(.*)/i;
	for (let i=0;i<wdg.length; i++) {
		var field = wdg[i].split(",");
		if (field[0].substr(0,2) == "//") continue		// comment
		if (field[0] == "RV") field[3] = -1				// for vertical Radio buttons
		while (field.length < 7) field[field.length] = "";
		field[0] = field[0].toUpperCase();		// upper-case control name
		if (typeof convertType[field[0]] != "undefined") {field[0]  = convertType[field[0]]}
		if (field[0] == "FORM") {
			for (var j=1;j<field.length;j++) if (field[j] != "") jsForm[j-1] = field[j];
			if (jsForm[0] != "") jsForm[7] = jsForm[0];
		} else if (field[0] == "CHECK") {
			formGen.prototype.addControl(controls,field[1],field.slice(2))
		} else if (field[0] == "DEFAULT") {
			storeDefaults(field.slice(1),defaults);
		} else if (field[0] == "DICT") {
			fg_dictionary = eval(field[1]);
		} else if (field[0] == "LINK") {
			if (typeof wType[field[1]] == "undefined" || wType[field[2]] == "undefined") {
				wdg.push("CE,,"+field[1] + ' or ' + field[2]+ " doesn't exists")
			} else {
				if (wType[field[1]] == "CMB") links[field[1]] = field[2];
				else links[field[2]] = field[1];
			}
		} else if (field[0] == "EVENT") {
			events[field[1]] = field.slice(2);
		} else if (field[0] == "REQ") {
			for (var j=1;j<field.length; j++) formGen.prototype.addControl(controls,field[j],Array("required","required"));
		} else if (field[0] == "AFTER" || field[0] == "BELOW") {			
			for (j=1;j< field.length;j++) {
				if (field[j] != "") {
					IDName = field[j];
					if (typeof widgets[IDName] == "undefined") wdg.push("CE,,AFTER BELOW: field "+field[j]+ " doesn't exists")
					else {
						if (j > 1) {	// those are the fields to after
							if (typeof aButtons[IDName] == "undefined") {	// it is not a button
								aButtons[IDName] = [field[0],field[1],widgets[IDName][2],widgets[IDName][0],""];
							} else {
								aButtons[IDName][0] = field[0];
								aButtons[IDName][1] = field[1];
							}
						}
					}
				}
			}
		} else if (field[0] == "GET") {
			field[2] = sanitize(field[2]);
			aGets.push(field);
		} else if (field[0] != "") {
			// normalization of parameters
			if (field[1] == "") field[1] = "fg_" + i;	// generated name
			var IDName = field[1];
			if (field[2] == "") field[2] = field[1];	// label
			field[2] = sanitize(field[2]);	// normalize
			if  (field[3] == "" && " GBR".search(field[0]) == -1) {		// if lacks length
				if (typeof lengths[field[0]] != "undefined") {field[3]  = lengths[field[0]]}
			}
			if (field[0] == "S") {	// slider range and step
				if (field[4] == "") {field[4] = "0";field[5] = "100";field[6] = "1";}
				var min = Number(field[4]);
				var max = Number(field[5]);
				var delta = Math.abs(max-min);
				if (field[6] == "") 
					field[6] = toString(1/(Math.pow(10,((Math.floor(log10(delta)-2) < 1)?-Math.floor(log10(delta)-2):0))));
				defaults[field[1]] = (max < min) ? min : min + 0.5 * (max - min)
			} else if (field[0].substr(0,2) == "NF") {	// floating point number
				field[6] = (Number(field[0].substr(2)) != NaN)? Number(field[0].substr(2)):0;
				field[0] = "NF";
			} else if (field[0] == "H") {defaults[field[1]] = sanitize(field[4]);}
			widgets[IDName] = field;
			wType[field[1]] = field[0];
			if (field[0] in btnTypes) {
				aButtons[IDName] = Array("BOTTOM","",field[2],field[0],field[4],field[5],field[3])
			} else {
				if (typeof types[field[0]] != "undefined") {
					typeForm += types[field[0]];		// for find the buttons to expose
				} else {
					field[2] = field[0] + " Unknown type"
					field[0] = "CE"
				}				
			}
		}
	}
	translate = formGen.prototype.translate;
	var formID = jsForm[7];
	frm = "<FORM id='"+jsForm[7]+"' method='POST'" + ((jsForm[2] != "" && jsForm[3] == "")?" action='"+jsForm[2]+"'":"") + ">";
	frm += "<Table class='fg_Table'>";
	if (jsForm[1] != "") {	// title **************
		var aTitle = jsForm[1].split(":");
		frm += "<tr><th class='fg_Title' colspan=3 id='"+formID+"fg_Title'>"
		for (let i = 0;i<aTitle.length;i++) {
		if (rgxIxmgFiles.test(aTitle[i])) frm += "<img src='"+aTitle[i]+"'>";
			else frm += translate(fg_dictionary,aTitle[i]);
		}
		frm += "</th></tr>";
	}
	var aWidgets = Object.keys(widgets);
	for (let i = 0;i<aWidgets.length;i++) {
		field = widgets[aWidgets[i]];
		wdgType = field[0];
		fieldName = field[1]; 
		var IDName = jsForm[0]+field[1];
		field[2] = translate(fg_dictionary,field[2]);
		const tdLabel = "\n<tr>"+setLabelClass(field[2],"td")+"<td>";
		if (wdgType in cTypes) {	// Comment fields
			var c = (wdgType == "C") ? "fg_Comment":(wdgType == "CS") ? "fg_Separator":"fg_Error";
			frm += "\n<tr><td colspan='3'><div id='" +IDName + "' class='"+c+"'>"+field[2]+"</div>";
			continue;
		}
		if (wdgType == "IB") {	// Inline graphic button			
			frm += "\n<tr><td colspan='3'>"+genButton(jsForm[0],fieldName,aButtons[fieldName]);
			delete aButtons[fieldName];
			continue
		}
		if (wdgType == "I") {	// Image field
			var img = "<img style='vertical-align:middle' src='"+field[4]+ "' id='" +IDName + "' title='"+field[5] + "'";
			if(field[3] != "") img+= " height='" + field[3]+"'";
			img += "><span></span>";
			if (typeof aButtons[IDName] == "undefined") frm += tdLabel+img;
			else {aButtons[IDName][4] = img;}		// this is an after
			continue;
		}
		if (wdgType == "H") {
			frm += "\n<input type='hidden' id='" + IDName + "' name='"+fieldName +"' value='"+ field[4] +"'>";	// hidden field
			continue;
		}
		if (wdgType == "B") continue;
		if (typeof aButtons[fieldName] == "undefined") frm += tdLabel;	// not after	
		if (wdgType == "CKB") {								// Check box *******************
			var ckb = "<input type='checkbox' id='"+IDName+"' name='"+fieldName+"' value='on'> " + translate(fg_dictionary,field[4]);
			if (typeof aButtons[fieldName] == "undefined") frm += ckb;
			else {aButtons[fieldName][4] = setLabelClass(field[2],"span")+ckb;}		// this is an after
		} else if (wdgType == "CKL") {						// Check list ******************
			var aItems = splitKeyValue(field.slice(4));
			frm += "<input type='hidden' id='"+IDName + "' name='"+fieldName+"'/>"
			var checked = 0;
			for (var ck=0;ck<aItems.length;ck++) {
				widgets[jsForm[0]+aItems[ck][0]] = Array("CKB",aItems[ck][0]);	// complete widgets
				var ckb = "<input type='checkbox' onChange='formGen.prototype.updCountCheckList(\""+IDName+"\",this.checked)'"
				+ " id='"+jsForm[0]+aItems[ck][0]+"' name='"+aItems[ck][0]+"' value='on' /> " + aItems[ck][1];
				if (ck < aItems.length-1) ckb += "<br>";
				frm += ckb;
				if (typeof defaults[aItems[ck][0]] != "undefined") checked++;
			}
			defaults[fieldName] = checked;
		} else if (wdgType == "CMB" || wdgType == "L") {	// combo and List **************
			singleName = fieldName;
			aLists[fieldName] = (field.slice(4)).join(",");
			if (wdgType == "CMB") {
				events["fg_"+singleName] = Array("change","formGen.prototype.handleEventOptions");				
				if (typeof links[fieldName] != "undefined") events["fg_"+singleName].push(links[fieldName]);
				var cmb = "<input type='hidden' name='"+fieldName +"_Group' id='"+IDName + "_Group'/>"
				+ "<SELECT id='"+IDName + "' name='"+fieldName +"'></SELECT>";
				if (typeof aButtons[fieldName] == "undefined") frm += cmb;
				else {aButtons[fieldName][4] = setLabelClass(field[2],"span")+cmb;}		// this is an after	
			} else {
				frm += "<input name='" + fieldName + "' id='" + IDName + "' list='" + IDName + "_List'/>"
				+ insertEraseMark(IDName,fieldName,events)
				+ "<datalist name='" + fieldName + "' id='" + IDName + "_List'></datalist>"			
			}
		} else if (wdgType == "S") {							// ***************** Slider *********************
			frm += "\n<input type=range id='"+IDName + "' name='"+fieldName +"' min='"+field[4]+"' max='"+field[5] + "'"
			if (field[6] != 0) frm += " step='" + field[6] + "'";
			frm += " onChange='$(\"s_\"+this.id).innerHTML = this.value'";
			frm += " style='width:" + field[3] + "px;vertical-align: middle'/>";
			frm += "<span id='s_" + IDName +"' style='display:inline-block;width:3em;padding-left:5px;vertical-align:middle'></span>";
		} else if (wdgType == "F") {					// File (before text!!! *************
			var accept = (field[4] != "") ? "accept='"+(field.slice(4)).join()+"' ":"";
			frm += "<input type=file " + accept + idNameSize(field) + "/>";
			jsForm[6] = "F";
		} else if (" TUNSNF".indexOf(wdgType) > 0) {		// T, U, UN, N, NS, NF **************
			if (field[3] > llText) {
				frm += "<textarea cols=50 rows="+Math.ceil(field[3] / llText);
				frm += " id='"+IDName + "' name='"+fieldName +"' class='fg_TextArea'></textarea>";
			} else {
				var txt = "";
				if (" N*NS*NF*UN*".indexOf(wdgType+"*") > 0) {
					txt += "\n<input type='number' " + idNameSize(field) + " style='text-align:right;width:" + field[3] +"em'";
					if (wdgType == "NF") {
						txt += " inputmode='decimal' step='" + 1/Math.pow(10,Number(field[6])) + "'";
					} else {
						txt += " inputmode='numeric'";
						if (wdgType == "N") {
							txt += " min='0'";
							formGen.prototype.addControl(controls,fieldName,Array("Min=0","Must be unsigned integer"));
						}
					}
					txt += "/>";
				} else {
					txt += "<input type='text' " + idNameSize(field,defaults) + "/>";
					if (wdgType.substr(0,1) != "U") {
						txt += insertEraseMark(IDName,fieldName,events);
					}
				}
				txt += translate(fg_dictionary,field[5]);
				if (typeof aButtons[fieldName] == "undefined") frm += txt;
				else {aButtons[fieldName][4] = setLabelClass(field[2],"span")+txt;}	// this is an after
			}
		} else if (wdgType == "P") {					// Password
			frm += "<input type=password " + idNameSize(field) + "/>"
				+ insertEraseMark(IDName,fieldName,events) + field[5];

		} else if (wdgType == "R") {		// *************** Radio buttons *******************
			singleName = fieldName;		// for possibly single				
			var aItems = splitKeyValue(field.slice(4));
			var evnt = ""
			if (typeof events[fieldName] != "undefined") {
				evnt = " on"+events[fieldName][0]+"='"+events[fieldName][1]+"(event)'";
				delete events[fieldName];
			}
			for (var ck=0;ck<aItems.length;ck++) {
				frm += "\n<input type='radio' name='"+fieldName+"' id='"+IDName+(ck) + "' value='"+ aItems[ck][0] + "'" +evnt +"/>";
				frm += ((Number(field[3]) > 0) ? "<span style='display:inline-block;width:" + (field[3]) + "px'>" + aItems[ck][1] + "</span>" : aItems[ck][1]);
				if (Number(field[3]) == -1) frm +="<br>";	// vertical radio buttons
				if (typeof defaults[fieldName] != "undefined") {
					if (aItems[ck][0] == defaults[fieldName] || aItems[ck][1] == defaults[fieldName]) defaults[fieldName] = ck;
				}
			}
			frm += "\n<input type='radio' name='" + fieldName + "' id='" + IDName + "' value='' CHECKED style='display:none'>";
		} else if (wdgType == "DATE") {
			frm += "<input type='date' name='" + fieldName + "' id='" + IDName + "'>";
		} else {
		}			
		let r = hasAfterBelow(fieldName,aButtons);
		if (r > 0) {	// for buttons below or after			
			var id = jsForm[0]+fieldName;	// ex. fg_resultiNumberAFTER
			if ((r & 1) == 1) frm += "<span id='"+id+"AFTER'></span>";
			if ((r & 2) == 2) frm += "<div style='text-align:center' id='"+id+"BELOW'></div>"
		}			
	}
	if (typeForm != "C") {			// if no only list type widget
		var isStatic = jsForm[4].toLowerCase() == "static";
		if (!existsSubmitButton(aButtons) && !isStatic) {
			aButtons["fg_Ok"] = Array("BOTTOM","","Ok","B","","","")
		}		
		frm += "<tr><td colspan=2 style='text-align:center' class='fg_Buttons'>";	// buttons are centered
		frm += "<div id='"+jsForm[0]+"BOTTOM'></div>";

		if (typeof aButtons["fg_Reset"] == "undefined" && typeForm != "") {aButtons["fg_Reset"] = Array("BOTTOM","","Reset","B","","","")}
		if (typeof aButtons["fg_Cancel"] == "undefined" && !isStatic) {aButtons["fg_Cancel"] = Array("BOTTOM","","Cancel","B","","","")}	// no cancel button if the form is static
		
	} else 	{
		if (field[0] == "R") {
				var rdbs = document.getElementsByName(fieldName);
				for (i=0;i<rdbs.length-1;i++) {
					events[singleName+(i)] = Array("click","formGen.prototype.handleSingle");
				}				
		} else {
			events[singleName] = Array("change","formGen.prototype.handleSingle");
		}
	}
	$(idDiv).innerHTML = frm+'</Table></FORM>';
	// add buttons	*********************
	for (j in aButtons) {
		$(jsForm[0]+aButtons[j][1]+aButtons[j][0]).innerHTML += genButton(jsForm[0],j,aButtons[j]);
	}

	if (callBack != "") callBack("Before",jsForm[7]);
	//	 add hidden	*********************
	addHidden($(jsForm[7]),'fg_Button')
	addHidden($(jsForm[7]),'fg_Changed')
	addHidden($(jsForm[7]),'fg_Store',store)
	// add controls	*********************
	for (field in controls) {
		if (field != "*") {		// general check
			if (typeof widgets[field] == "undefined") {
				alert ("Control " + field + " not exists")
				delete controls[field];
			} else {
				$(jsForm[0]+field).onblur = function(){check(this.form,this)};
			}
		}
	}
/* 	if (jsForm[7] != "") {	// if exists form id
			$(jsForm[7]).addEventListener('keypress', function(event) {		// prevent enter
            if (event.keyCode == 13) {event.preventDefault();});
	}
 */
 // store object variables
	formGen[store] = {jsForm: jsForm,
			defaults: defaults, 
			widgets: widgets, 
			controls: controls,
			listGroups: listGroups,
			aLists: aLists,
			createOptions:createOptions,
			callBack: callBack,
			check:check,
			buttons:aButtons
			};
// add events	*************************************************
	for (var name in events) {
		var eField = jsForm[0]+((name.substr(0,3) == "fg_") ? name.substr(3) : name);	// fg_ permets adding second handler at combo
		var e = events[name];
		if ($(eField) == null) {console.log(eField + ": event field not present");return}	
		if (e[1].trim() == "") {console.log(eField + ": function not present");return}
		if (e[0].toLowerCase() == "enter") e[0] = "keypress";
		if (eval("typeof " + (e[1])) != "function") {
			if (e[1].toLowerCase() == "submit") {
				if (e[0] == "keypress") $(eField).addEventListener(e[0],eval("formGen.prototype.handleEnter"));
				else $(eField).addEventListener(e[0],eval("formGen.prototype.handleSingle"));
			} else console.log(eField + ": " + e[1] + " isn't function")				
		} else $(eField).addEventListener(e[0],eval(e[1]).bind(event,e[2],e[3],e[4]))			
	}
/********************  handle GET pseudo type ********************/
	for (var i=0;i<aGets.length;i++) {
		field = aGets[i];
		var millisecs = parseInt(field[3],10);
		field[3] = (millisecs > 0) ? millisecs:0;
		if(field[3] == 0) {	// interval refresh field
			ajaxEvent++;
			if (field[1] != "*") {				
				if ($(jsForm[0]+field[1]) == null) console.log(field[1] + " get field not present")				
				else {
					if (widgets[field[1]][0] == "CMB" || widgets[field[1]][0] == "L") {
						formGen.prototype.ajax(field[2],field[1],function(c,fld){ajaxEvent--;aLists[fld] = c});	// get combo items
					} else {
						formGen.prototype.ajax(field[2],field[1],function(c,fld){ajaxEvent--;	// simple field
						defaults[field[1]] = c;});
					}
				}
			} else {
				formGen.prototype.ajax(field[2],"",function(c){
					ajaxEvent--;storeDefaults(c,formGen[store]["defaults"])
					})
			}
		}
	}
	var handleInterval = setInterval(waitAjax,500,2000+ajaxEvent*2000)	// second parameter for wait all events
	return {
		createOptions:createOptions,
		storeDefaults:storeDefaults,
		check:check,
		formFields:formFields,
		fg_FormID: jsForm[7]
	}
	function waitAjax(totalWait) {	// this function updates combos and sets defaults	
	if (typeof waitAjax["t"] == "undefined") {waitAjax["t"] = 0}
		waitAjax["t"] += 500
		if (ajaxEvent == 0) {
			clearInterval(handleInterval);
			formGen.prototype.setDefaults(store);		// set defaults			
			var frm = $(formID);
			fieldsAtStart = formFields($(formID));	// save initial form values
			for (var i=0;i<aGets.length;i++) {	// second loop after setDefaults occurred
				field = aGets[i];
				if(field[3] > 0) {	// interval refresh field
					handleSetTimeout(field,jsForm);
				}
			}
			if (callBack != "") callBack("Start",jsForm[7]);
			// store object variables
			formGen[store]["fieldsAtStart"] = fieldsAtStart;	// here
		} else {
			if (waitAjax["t"] > totalWait) {
				clearInterval(handleInterval);
				alert("Ajax timeout");
			}
		}
	}
	function handleSetTimeout(field,jsForm) {
		if ($(jsForm[7]) != null) {	// form yet present
			formGen.prototype.ajax(field[2],"",function(c){
				setValue(jsForm,field[1],c);				
			})
			setTimeout(handleSetTimeout,field[3],field,jsForm)
		}
	}
 	function setValue(jsForm,name,value) {	//Used by GET timeout		
		var field = widgets[name];
		if (widgets[name] == undefined) return;
		var fld = $(jsForm[0]+name);	// the control id
		if (field[0] == "C") {		// comment fld is cell (TD)
			fld.innerHTML = field[2] + ((field[2][field[2].length-1] != " ")? " ":"") + value;
		} else if (field[0] == "I") {
			var a = value.split(/\t/);
			fld.src = a[0];
			if (a.length > 1) fld.nextSibling.innerHTML = "  "+a[1];
		} else {
			fld.value = value;	// text I suppose		
		}		
	}
};
formGen.prototype.IDEvent = function(e) {
	if(window.event) return event.srcElement.id;	// IE
	else return e.target.id;  						// Netscape/Firefox/Opera
}
formGen.prototype.handleEventOptions = function (linkField) {
	if (typeof linkField != "undefined") {event.target.form[linkField].value = event.target.value;}
	formGen.prototype.setGroupName(event.target);}
formGen.prototype.handleSingle = function () {	// for capture single combo
	if (event.target.tagName == "SELECT") {
		formGen.prototype.setGroupName(event.target);
	}
	event.stopImmediatePropagation();
	formGen.prototype.handle(event.target.form,event.target.id);	
}
formGen.prototype.setGroupName = function (opt) {	// set the possible combo group name
	var listGroups = formGen[opt.form.fg_Store.value]["listGroups"]
	$(opt.id + "_Group").value = listGroups[opt.id + opt.options[opt.selectedIndex].value];
}
formGen.prototype.handleEnter = function () {	// for capture enter key
	if (event.keyCode == 13) formGen.prototype.handle(event.target.form,event.target.id,"submit");
}
formGen.prototype.handle = function (frm,button,customHandler) {	// send request
	if (typeof customHandler == "undefined") customHandler = "";
	var store = frm.fg_Store.value;
	var jsForm = formGen[store]["jsForm"];
	var aButtons = formGen[store]["buttons"];
	if (button.substr(0,jsForm[0].length) == jsForm[0]) button = button.substr(jsForm[0].length)
	frm.fg_Button.value = button;
	btnPosition = (typeof aButtons[button] != "undefined") ? aButtons[button][0] : "";
	if (button != "fg_Cancel" && (customHandler == "submit" || btnPosition == "BOTTOM")) {
		var aErrors = formGen[store]["check"](frm);		// data control ******************
		if (aErrors.length > 0) return alert("Errors:\n"+aErrors.join("\n"));
	}
	// set names of modified fields
	frm["fg_Changed"].value = formFields(frm,true);
	if (customHandler != "") {		// button handled
		if (customHandler != "submit") return customHandler(frm);
	}
	var formParms ={"URI":jsForm[2],"ajaxFunction":jsForm[3],"action": jsForm[4].toLowerCase(),
					"erase":false,"container":store.substr(3),"store":store,"target":jsForm[5].toLowerCase()}
	if (button == "fg_Cancel") formParms.erase = true;
	else {
		if (formParms.target == "" || formParms.target == "_self") {
			if(formParms.action != "reset" && formParms.action != "static") formParms.erase = true;
		}
	}
	if (formParms.URI != "" && formParms.ajaxFunction == "") {		// only URI
		if (button != "fg_Cancel") {
			if (jsForm[6] == "F") frm.encoding = "multipart/form-data";	// for files
			frm.action = formParms.URI;
			if (formParms.target != "") frm.target = formParms.target == "newwindow"?"_blank":formParms.target;
			frm.submit();
		}
	} else if (formParms.URI == "" && formParms.ajaxFunction != "") {		// only call function
		if (button == "fg_Cancel") {
			var form = document.createElement("form");
			form.setAttribute("id",frm.id);
			form.setAttribute("method",frm.method);
			$(formParms.container).replaceChild(form,frm);
			frm["fg_Button"].value = "fg_Cancel";
		}
		window[jsForm[3]](frm);
	} else if (formParms.URI != "" && formParms.ajaxFunction != "") {		// call Ajax receive in function
		if (jsForm[6] == "F") frm.encoding = "multipart/form-data";	// for files
		if (button == "fg_Cancel") {					//	27 IX 2020
			frm.innerHTML ="<input type=hidden name=fg_Button value='fg_Cancel'>"
		}
		var handleAjax = function(response,frm,handler2,parms) {	// handler(ajx.responseText,frm,handler2,frm,parms)
			handler2(response,frm);		
		}
		formGen.prototype.ajax(jsForm[2],frm,handleAjax,window[formParms.ajaxFunction],formParms);

	} else {
		if (button == "fg_Cancel") {
			frm.innerHTML ="<input type=hidden name=fg_Button value='fg_Cancel'>"
		}
		$(jsForm[7]).innerHTML = formGen.prototype.getData(frm);
		formParms.erase = false;
	}
	if (formParms.erase) {
		$(frm.id).parentNode.removeChild($(frm.id));
		if (formGen[store]["callBack"] != "") formGen[store]["callBack"]("End",jsForm[7])
	} else {
		if(formParms.action == "reset") setTimeout(function(){formGen.prototype.setDefaults(store)},100);
		if (formGen[store]["callBack"] != "") formGen[store]["callBack"]("AfterSubmit",jsForm[7])
	}
}
formGen.prototype.dropCommaSemicolon = function(s) { // deMask , ; = &
	 if (s.substring(0,1) == "@") s = aRep[s];
	 return s.replace(/\\x2C|\\x3B|\\x3D|\\x26/gi,function(s){return String.fromCharCode(parseInt("0"+s.substr(1)))});
};

 /* formGen.prototype.splitKeyValue = function(aSplit) {	// return array of items
	var aRet = new Array();
	for (var i in aSplit) {
		if (!/^\s*$/.test(aSplit[i])) {
			var a = aSplit[i].split("=")
			a[a.length-1] = translate(fg_dictionary,sanitize(a[a.length-1]))
			aRet[aRet.length] = [a[0],(a.length > 1) ? a[1]:a[0]];
		}
	}
	return aRet;
} */
formGen.prototype.ajax = function(url,frm,handler,handler2,parms) {
	var data = (typeof(frm) == "string")? frm :new FormData(frm);
	var ajx = new XMLHttpRequest();
	ajx.onreadystatechange = function(){
	if (ajx.readyState == 4) {
		if (ajx.status == 200) {
			if(typeof handler2 != "undefined") return handler(ajx.responseText,frm,handler2,parms)
			else return handler(ajx.responseText,frm);
		}		// the second parameter is data itself
			alert("Error: " + ajx.status + ": " + ajx.statusText);
		}
	}
	ajx.open("POST", url, true)
	if (typeof data != "object") {ajx.setRequestHeader("Content-type", "application/x-www-form-urlencoded")}
	ajx.send(data);
}
 formGen.prototype.getData = function(frm) {
	var r = "<table border=1 cellpadding='5'>";
	for (i = 0; i < frm.length; i++) {
		c1 = "<tr><td>"+frm.elements[i].name+"<td>";
		switch (frm.elements[i].type) {
			case "checkbox":
				r += c1+((frm.elements[i].checked)?frm.elements[i].value:"");
				break;
			case "radio":
				if (frm.elements[i].checked) r += c1+frm.elements[i].value;
				break;
			case "button":
				break;
			default:
				r += c1+frm.elements[i].value;
		}
	}
	return r+"</table>";
}
formGen.prototype.setDefaults = function(storeStruct,widget) {
	var defaults = formGen[storeStruct].defaults;
	var widgets = formGen[storeStruct].widgets;
	var jsForm = formGen[storeStruct]["jsForm"];
	var aLists = formGen[storeStruct]["aLists"];
	for (i in widgets) {
		var field = widgets[i];
		var value = "";
		if (widget != field[1] && typeof widget != "undefined") continue;
		if (typeof defaults[field[1]] != "undefined") value = defaults[field[1]];
		var id = jsForm[0]+field[1];	// the name of control
		if (field[0] == "CKB") {
			if (value.toLowerCase() == "on" || value.toLowerCase() == "checked") $(id).checked = true;
			else $(id).checked = false;
		} else if (field[0] == "CKL") {
			$(id).value = value;
		} else if (field[0] == "S") {
			if (value != "") $(id).value = value;
			$("s_"+id).innerHTML =  value;	// $(id).value;
		} else if (field[0] == "DATE") {
			if (value.toLowerCase() == "today") {
				var d = new Date();
				$(id).value = d.getFullYear() + "-" + ('0' + (d.getMonth() + 1)).slice(-2) + "-" + ('0' + d.getDate()).slice(-2);
			}
		} else if (field[0] == "B" || field[0] == "GB") {
			if (value.toLowerCase() == "off") $(id).disabled = true;
		} else if (field[0] == "R") {
			$(id+value).checked = true;
		} else if (field[0] == "CMB" || field[0] == "L") {
			formGen[storeStruct]["createOptions"](id,aLists[field[1]])	// this sets also default
			if (field[0] != "L") $(id + "_Group").value = "";
			if ($(id).selectedIndex > -1) formGen.prototype.setGroupName($(id));
		} else if (field[0] == "I") {
			if (value != "") $(id).src = value;
		} else if (field[0] == "F") {
		} else {
			if ($(id) != null) {
				$(id).value = value;
			}			
		}
	}
}
formGen.prototype.addControl = function(controls,name,control) {	
	if (name == "") return;
	if (typeof controls[name] == "undefined") a = Array()
	else a = controls[name];
	for (var i=0;i<control.length;i=i+2) {
		if (control[i] == "") break;
		var aItems = ["","",(i==control.length)?"":control[i+1]];	// signal
		var a2 = control[i].split("=");
		aItems[0] = a2[0].toUpperCase();	// "MIN","MAX","MAIL","PATTERN","REQUIRED","FUNCTION"
		if (a2.length > 1) {
			aItems[1] = a2[1]
		}
		a[a.length] = aItems;
	}
	controls[name] = a;
}
formGen.prototype.handleClick = function(e) {
	var targ;
	if (!e) var e = window.event;
	if (e.target) targ = e.target;
	else if (e.srcElement) targ = e.srcElement;
	if (targ.nodeType == 3) targ = targ.parentNode; // defeat Safari bug
	if (targ.innerHTML == "\u2718" && targ.localName == "span") {	// Unicode delete
		var store = targ.previousSibling.form.fg_Store.value;
		formGen.prototype.setDefaults(store,targ.previousSibling.name);
	}
}
formGen.prototype.updCountCheckList = function(id,checked) {
		$(id).value = Number($(id).value) + (checked?1:-1)
}
formGen.prototype.translate = function(obj,w) {
		return (typeof obj[w] == "undefined") ? w: obj[w].replace("\n","<br>");
}